;Replacement random-number generator for cc65.  Intended for the C64 but, as
;this program doesn't mess around with hardware or the OS, it *should* work
;with other systems as well.
;
;To use:
;-------------
;The prototypes are as follows:
;
;	unsigned __fastcall__ rand(void);
;	unsigned __fastcall__ rand2(unsigned);
;
;Use rand() to get the random number as usual, or rand2() to factor in a
;number into the randomizing process.
;
;Tip: If the constants in this module are set properly, it should not repeat
;for 64k times.  For more randomness, use rand2() and factor in an ever-
;changing number (i.e. rand2(i++) where i is defined as an unsigned, or a
;time or scan register).  This should make random numbers even better.

	.importzp	ptr1
      	.export		_rand, _srand

.data

; The seed. When srand() is not called, the C standard says that that rand()
; should behave as if srand() was called with an argument of 1 before.
rand:  	.word   1

.code

_rand:
;0 arg. by default.
;	lda	#0
;	tax
;noarg:
;;Add current value to seed.
;	clc
;	adc	rand
;	tay
;	txa
;	adc	rand+1
;	tax
;	tya
;	lda	#0
;	tax
	lda	rand
	ldx	rand+1
;Add $6292.
;XOR by $93F3.
	clc
	adc	#$92
	eor	#$F3
	tay
	txa
	adc	#$62
	eor	#$93
	tax
	tya
;	eor	#$F3
;	tay
;	txa
;	eor	#$93
;	tax
;	tya
	;sta	ptr1
pha
	stx	ptr1+1
	lsr
	;lda	ptr1
pla
	ror	ptr1+1
	ror
	ldx	ptr1+1
;Store new seed.
	sta	rand
	stx	rand+1
;Add $9732.
	clc
	adc	#$32
	tay
	txa
	adc	#$97
	tax
	tya
;XOR by $6065.
	eor	#$65
	tay
	txa
	eor	#$60
	tax
	tya
;Rotate seed right 1 bit.
	;sta	ptr1
	;tay
	;stx	ptr1+1
	;txa
	;asl
	;tya
	;rol
	;rol	ptr1+1
;Swap bytes.
;	stx	ptr1
;	tax
;	lda	ptr1
;Clear sign bit as in orig. routine.
;	tay
;	;lda	ptr1+1
;	txa
;	and	#$7F
;	tax
;	tya
	rts


_srand:	sta	rand+0		; Store the seed
	stx	rand+1
	rts


